----Indst Premiummgleres nedtagne Premiumannoncer fra forrige mned i tabellen PremiumFakturering: 
--insert into PremiumFakturering(BoligID, AgentRegID, lastchange) 
--select * from PremiumFaktureringView pfv where pfv.boligid not in (select boligid from PremiumFakturering);
--
----Slet boligannoncer, som er kommet p nettet igen (udbudt til salg igen), fra PremiumFakturering:
--delete pf
--from PremiumFakturering pf
--	inner join Bolig b on b.ID = pf.BoligID
--where 
--	pf.lastchange != b.lastchange;
--
----Opdater salg_id i Premiumfakturering, hvis en bolig i tabellen er blevet solgt:
--update PremiumFakturering
--set salg_id = s.salg_id
--from
--	PremiumFakturering p
--	inner join PropertyDataV3Sales s on p.BoligID = s.boligid;

--Trk Premiummgleres nedtagne Premiumannoncer fra forrige mned:
declare @start_time datetime = '2022-05-01'; 
declare @end_time datetime = '2022-05-31 23:59:59';

with t1 as(
	select distinct
		pf.AgentRegID [MglerguideID]
		,ardk.Name [Mgler]
		,pf.BoligID [BoligID]
		,bt.BoligType [Boligtype]
		,b.Gade [Adresse]
		,b.Postnr [Postnr.]
		,case when k.navn is null then '-' else k.navn end [Kommune]
		,CONVERT(DATE, pf.lastchange) [Nedtagningsdato]
		,case when pf.Kategori = 2 then 'Solgt med forbehold fra tidligere liste'
			else case when pf.salg_id is not null then '1 - Solgt'
			else case when 
					(b2.ID is not null and b2.DomainID != b.DomainID) -- Ny ejendomsmglerkde
					or (b2.ID is not null and b2.AgentID != b.AgentID) -- Ny mgler inden for samme kde
					or (b2.DomainID in (4, 691) and b.DomainID in (4, 691) and b2.AgentID != b.AgentID) -- Ny mgler inden for samme kde (Estate)
				then '3 - Retursag' 
				else 'Formodet solgt' end end end [rsag til nedtagning]
		,ROW_NUMBER () OVER (partition by pf.AgentRegID, b.Gade, b.Postnr order by pf.Kategori, b.BoligTypeID) [rn]

	from 
		PremiumFakturering pf
		inner join Bolig b on b.ID = pf.BoligID
		inner join AgentRegDK ardk on ardk.Id = pf.AgentRegID
		left join BoligType bt on bt.ID = b.BoligTypeID
		left join Kommuner k on k.id = b.KOMMUNE_NR
		outer apply (
				select top 1
					b2.ID
					,b2.Gade
					,b2.EJD_NR
					,b2.KOMMUNE_NR
					,b2.Oprettet
					,b2.Status
					,b2.AgentID
					,b2.DomainID
				from
					Bolig b2
				where
					(b2.Status is null or b2.Status = 0)
					and ((case when b2.EJD_NR = 0 then null else b2.EJD_NR end) = b.EJD_NR 
					or b2.Gade = b.Gade)
					and b2.KOMMUNE_NR = b.KOMMUNE_NR 
					and DATEDIFF(DAY, b2.Oprettet, b.lastchange) < 7 
					and b.Oprettet < b2.Oprettet
					and not (b2.AgentID = b.AgentID and b2.DomainID = b.DomainID)
					and not (b2.DomainID in (4, 691) and b.DomainID in (4, 691) and b2.AgentID = b.AgentID)
				order by
					b2.Oprettet
				) b2 
		cross apply(
			select top 1
				apbl.AgentRegId
				,apbl.PremiumStartBilling
				,apbl.PremiumStopBilling
			from
				AgentPremiumBillingLog apbl
			where
				apbl.AgentRegId = ardk.Id
				and apbl.PremiumStartBilling <= @end_time
				and (apbl.PremiumStopBilling >= @start_time or apbl.PremiumStopBilling is null)
			order by
				apbl.PremiumStartBilling desc
			) apbl

	where 
		(pf.lastchange between @start_time and @end_time
		or pf.Kategori = 2)
)

select
	t1.MglerguideID
	,t1.Mgler
	,t1.BoligID
	,t1.Boligtype
	,t1.Adresse
	,t1.[Postnr.]
	,t1.Kommune
	,t1.Nedtagningsdato
	,t1.[rsag til nedtagning] 
from 
	t1 
where 
	rn = 1 
order by 
	t1.Mgler
	,t1.Nedtagningsdato
