--Tjekker, om der i lbet af forrige mned er kommet nye Premiummglere, 
-- eller om der er Premiummglere, som er stoppet.
--En ny Premiummgler defineres som en mgler, der ikke har vret Premium 
-- i lbet af mneden fr starten p dens nuvrende Premiumperiode.

declare @month int = 05; --Sidste mned
declare @year int = 2022; --r for sidste mned

select 
	apbl.AgentRegId
	,ardk.Name
	,apbl.PremiumStartBilling
	,apbl.PremiumStopBilling 
	,case when DATEPART(MONTH, apbl.PremiumStartBilling) = @month 
		and DATEPART(YEAR, apbl.PremiumStartBilling) = @year
		and tidligere_periode.AgentRegId is null then 'Startet'
	else case when DATEPART(MONTH, apbl.PremiumStopBilling) = @month
		and DATEPART(YEAR, apbl.PremiumStopBilling) = @year then 'Stoppet' end end [Type]
from 
	AgentRegDK ardk
	cross apply(
		select top 1 *
		from
			AgentPremiumBillingLog apbl
		where
			apbl.AgentRegId = ardk.Id
		order by
			apbl.PremiumStartBilling desc
	) apbl --seneste Premiumperiode
	outer apply(
		select top 1
			apbl2.AgentRegId
		from
			AgentPremiumBillingLog apbl2
		where
			apbl2.AgentRegId = apbl.AgentRegId
			and apbl2.PremiumStartBilling != apbl.PremiumStartBilling
			and apbl2.PremiumStopBilling <= apbl.PremiumStartBilling
			and DATEDIFF(MONTH, apbl2.PremiumStopBilling, apbl.PremiumStartBilling) <= 1 --Den tidligere Premiumperiode skal vre startet i lbet af mneden fr dens tidligere periode
		order by
			apbl2.PremiumStartBilling desc
	) tidligere_periode

where 
	apbl.AgentRegId != 25546 --Testmgler
	and ((DATEPART(MONTH, apbl.PremiumStartBilling) = @month 
		and DATEPART(YEAR, apbl.PremiumStartBilling) = @year
		and tidligere_periode.AgentRegId is null) --Startet i forrige mned
	or (DATEPART(MONTH, apbl.PremiumStopBilling) = @month
		and DATEPART(YEAR, apbl.PremiumStopBilling) = @year)) --Stoppet i forrige mned
order by
	apbl.PremiumStartBilling